#include <p33fj128mc802.h>
#include <dsp.h>
#include <stdlib.h>
#include ".\include\definition_of_constants.h"

void DAConv(unsigned int a, signed int b);
signed long limiter(signed long a, signed long b);
signed long arctan(signed long a, signed long b);

void observer(void)
{
    extern signed long  a11;                                    // IuU[op[^
    extern signed long  iu, iv, iw;                             // dol
    extern signed long  vu_com, vv_com, vw_com;                 // dwߒl
    extern signed long  i_alpha_estd, i_beta_estd;              // dl
    extern signed long  cos_theta_estd, sin_theta_estd;         // 𐔐l
    extern signed long  w_det;                                  // ]oli]̐^lƂDj
    extern fractional   w_com;                                  // ]wߒl
    extern signed long  w_estd;                                 // ]l
    extern signed long  theta_estd;                             // [^ʒu

    signed long         a12, a22;                               // IuU[op[^
    extern signed long  g2;                                     // tB[hobNQC
    signed long         i_alpha, i_beta;                        // dol
    signed long         di_alpha_estd, di_beta_estd;            // dll
    signed long         dcos_theta_estd, dsin_theta_estd;       // 𐔔ll
    signed long         dw_estd;                                // ]ll
    signed long         v_alpha, v_beta;                        // dwߒl
    signed long         s_alpha, s_beta;                        // sM
    
    extern fractional ADCBuffer[] __attribute__((space(dma)));  //ADϊʂDMAɂ]w

    extern unsigned long    i_start;                            // dol[_␳ԗpJE^
    extern signed int       iu_offset, iv_offset;               // dol[_␳l

    
       _LATA2 = 0; 					// 9ԃsI

// dol
    iu = ADCBuffer[2] - iu_offset;                              // dol̃[_␳
    iv = ADCBuffer[3] - iv_offset;   
    iw = -iu - iv;
    
// dol[_␳llp
    if(i_start-- > 1)                                           // dol̃[_͖ɂD
    {                                                           // ŁCvOsJn5biu, iv̐ϕl߂āC[_Ƃ
        iu_offset += iu/256;                                    // [_␳ll͒葬^]]܂D
        iv_offset += iv/256;
    }else{
        i_start = 1;
    }
    
// dwߒľŒ菬_Z            
    vu_com = (vu_com * VolRatio)>>10;                           // -1333 -- 1333 ̒l𕄍tŒ菬_ -1 - 0.999 ɊZ
    vv_com = (vv_com * VolRatio)>>10;                           //  1333 @2^15 = 32767 ɑΉÂD@1333*32* 0.7681 = 32763
    vw_com = (vw_com * VolRatio)>>10;                           //  vu_com * 2^5 * VolRatio/2^15

//    DAConv((vu_com+0x8000)>>4 , 0x7000);                      // dwߒl`lAI
//    DAConv((vv_com+0x8000)>>4, 0xF000);                       // dwߒl`lBI

    // -ϊ
    v_alpha = (vu_com * c11 + vv_com * c12 + vw_com * c13)>>15;
    v_beta  = (               vv_com * c22 + vw_com * c23)>>15;
    i_alpha = (iu     * c11 + iv     * c12 + iw     * c13)>>15;
    i_beta  = (               iv     * c22 + iw     * c23)>>15;
    
//    DAConv(((v_alpha>>1)+0x8000)>>4 , 0x7000);                // dwߒl`lAI v_alpha 2^15𒴂邱Ƃ̂ŁC1^2{ĕ\
//    DAConv(((v_beta>>1)+0x8000)>>4, 0xF000);                  // dwߒl`lBI v_beta 2^15𒴂邱Ƃ̂ŁC1^2{ĕ\
//    DAConv(((i_alpha<<2)+0x8000)>>4 , 0x7000);               // dol`lAI
//    DAConv(((i_beta<<2)+0x8000)>>4, 0xF000);                 // dol`lBI

    // XCb`OMvZ
    if(i_alpha_estd >= i_alpha)
    {
        s_alpha = k_gain;
    }else{
        s_alpha = -k_gain;
    }
    if(i_beta_estd >= i_beta)
    {
        s_beta = k_gain;
    }else{
        s_beta = -k_gain;
    }
    
 // p[^vZ
    a12 = (w_estd * a12_0)>>15;                         // a12, a22 vZ
    a22 = (w_estd * a22_0)>>15;
   
// ]ɂtB[hobNQC̕ύX
    if(w_com >= 0)                                      // ]Fg2 > 0Ct]Fg2 < 0
    {
        g2 = g2_0;
    }else{
        g2 = -g2_0;
    }
 
// XCfBOIuU[o 
    // d
    di_alpha_estd = ((a11 * i_alpha_estd - a12 * sin_theta_estd + b1 * v_alpha)>>15) + s_alpha;
    di_beta_estd  = ((a11 * i_beta_estd  + a12 * cos_theta_estd + b1 * v_beta )>>15) + s_beta;
    // ϕ
        i_alpha_estd += di_alpha_estd;
        i_beta_estd  += di_beta_estd;
        
    // 𐔐
    dcos_theta_estd = (- a22 * sin_theta_estd + g1 * s_alpha - g2 * s_beta)>>15;
    dsin_theta_estd = (  a22 * cos_theta_estd + g2 * s_alpha + g1 * s_beta)>>15;
        // ϕ
        cos_theta_estd += dcos_theta_estd;
        sin_theta_estd += dsin_theta_estd;
        // ~b^
        cos_theta_estd = limiter(cos_theta_estd, 32767);
        sin_theta_estd = limiter(sin_theta_estd,  32767);

        
//    DAConv(((i_alpha_estd<<2)+0x8000)>>4 , 0x7000);           // dl`lAI 
//    DAConv(((i_alpha<<2)+0x8000)>>4, 0xF000);                 // dol`lBI
//    DAConv(((i_beta_estd<<2)+0x8000)>>4 , 0x7000);            // dl`lAI
//    DAConv(((i_beta<<2)+0x8000)>>4, 0xF000);                  // dol`lBI
//    DAConv(((cos_theta_estd)+0x8000)>>4, 0x7000);             // 𐔐l`lAI
//    DAConv(((sin_theta_estd)+0x8000)>>4, 0xF000);             // 𐔐l`lBI
    
// [^ʒulvZ
// arctan(sin_theta_estd/cos_theta_estd)̌vZ @i-/2 -- 3/2  0 -- 1024͈̔͂ŏo, POS1CNTɍĂDj
    theta_estd = arctan(cos_theta_estd, sin_theta_estd);

//    DAConv(theta_estd<<1, 0xF000);                        // [^ʒul`lBI
//    DAConv(POS1CNT<<1, 0x7000);                           // [^ʒul`lBI
    
// ]lvZ
    dw_estd = (-s_alpha * sin_theta_estd + s_beta * cos_theta_estd)>>15; 
    // ϕ  
    w_estd += g_s * dw_estd;
    
    DAConv((w_estd+0x8000)>>4,   0xF000);                       // ]l`lBI
//    DAConv((w_com+0x8000)>>4,   0x7000);                        // ]wߒl`lAI
    DAConv(((w_det<<6)+0x8000)>>4, 0x7000);                 // ]ol`lAI
//    DAConv(((w_det<<6)-w_estd+0x8000)>>4, 0xF000);         // ]덷`lAI
    
   _LATA2 = 0; 					// 9ԃsIt
    
}

